extern unsigned int width, height, GridHeight, GridWidth,GridX,GridY,Ymin,Ymax;
extern int deltaY;
extern void interrupt (*altvec)(void);
extern unsigned int mess[], im, imm;
extern int dbcal[], dbmess[],dbmin, dbmax, deltadb;
extern float fcal[],fu, fo, deltaf, fc, f_adder;
extern int raster[];	     //adc-raster(plot-raster)
extern BYTE band;
extern float frequenz();
extern void out_dac();
extern void f_cal();
extern void out_f();
extern void out_debug();
extern void out_sweeptime();
extern BYTE modus; //0: ADC lesen und DAC weiterschalten
		   //1: Timer
		   //2: Counter
		   //3: hold
extern BYTE segment; //aktuell beschriebenes Segment von mess
extern int timer;	//Timer wird per Interrupt dekrementiert
extern BYTE cevent;	//0: 1. mal warten auf Counter 1. Zhlung: fu
			//1: 2. mal warten auf Counter 1. Zhlung: fu
			//2: 1. mal warten auf Counter 2. Zhlung: fo
			//3: 2. mal warten auf Counter 2. Zhlung: fo
extern int inttimer;
extern float ZF;
extern int nfcal;
extern float dfcal;
extern void inttofile(int vec[], int anz, char name[]);
extern char kaltstart;
extern int dac_inc, dac_value, dac_old;
extern int sweep_t[];
extern char sweep_dac[];
extern char sweep_str[10][6];
extern char sweep_n, sweep_i;
extern int inttimer;
extern int dac_inc;
extern int bottomline;
extern int nmark;
extern int lx,lpos,rx,rpos,lrdb,maxx;


char thru;
int tcal[];

void interrupt adc(void)
{
unsigned int erg;
float position;
asm { dw 6066h }  // PUSH AD 32bit
switch ( modus)
 {
 case 0:
    {
    dac_old=dac_value;
    dac_value=dac_value-dac_inc;
    if ((dac_value > raster[im+1]) & (dac_value >= 0))
      {
       out_dac(dac_value);
       asm {
	    dw 6166h
	    mov al,20h	//Interrupt abgeschlossen
	    out 20h,al
	   }
       return;
      }
    asm	{
	mov dx,141h	/* ADC Hi Port */
	in al,dx
	and al,15
	mov ah,al
	dec dx
	in al,dx
	mov erg,ax      /* ADC Ergabnis nach erg */
	}
    outp(0x141,0);	// ADC fr neue Messung starten
    if (thru)
       dbmess[imm]=dbcal[erg]-tcal[im];
    else
       dbmess[imm]=dbcal[erg];
    if (dbmess[imm] < dbmin*100)
      {
       mess[imm]=Ymin;
       goto weiter;
      }
    if (dbmess[imm] > dbmax*100)
      {
       mess[imm]=Ymax;
       goto weiter;
      }
    mess[imm]=Ymin+(dbmess[imm]/100.-dbmin)/deltadb*deltaY;  //Skalierung auf Bildschirm
weiter:
    imm++;
    im++;                //naechster Grid-Punkt
    if (im > GridWidth)  //Mess-Ende erreicht
      {
       timer=1.19318e6/inttimer*20.e-3;	//20 ms fr Teilerfaktor clock=16
       modus=1;
       im=0;
       segment=(segment+1) & 3;
       imm=im+segment*1024;
       dac_old=dac_value;
       dac_value=4096;
       PutString(0,bottomline," ",1);
      }
    else		 //Messung noch nicht abgeschlossen
      {
       dac_value=raster[im];  //raster[im]=zum Gridpunkt im gehoeriger DAC-Wert
       out_dac(dac_value);
      }
    asm {
	 dw 6166h
	 mov al,20h	//Interrupt abgeschlossen
	 out 20h,al
	}
    return;
    }
 case 1:
    {
     timer--;
     if (timer==0)
       {
	modus=2;
       }
     asm {
	  dw 6166h
	  mov al,20h	//Interrupt abgeschlossen
	  out 20h,al
	 }
     return;
    }
 case 2:
    {
     if ((cevent & 1)==0)
	{
	 cevent++;
	 timer=1.19318e6/inttimer*20.e-3; //20 ms fr Teilerfaktor clock=16
	 modus=1;
	}
     else
	{
	 if (cevent==1)
	  {
	   fu=frequenz()-ZF;
	   out_dac(raster[im]);
	   timer=1.19318e6/inttimer*20.e-3; //20 ms fr Teilerfaktor clock=16
	   modus=1;
	   cevent=2;
	  }
	 else //cevent=3
	  {
	   outp(0x141,0);  // ADC fr neue Messung starten
	   fo=frequenz()-ZF;
	   deltaf=fu-fo;
	   fc=0.5*(fu+fo);
	   cevent=0;
	   f_cal();
	   modus=0;
	   PutString(0,bottomline,"*",1);
	  }
	}
    }
 }
asm {
     dw 6166h   //POP AD 32bit
     mov al,20h	//Interrupt abgeschlossen
     out 20h,al
    }
return;
}
//Hier ist die Interruptroutine zu Ende!!!


int read_dbcal( void)
{
  int i,result;
  float y;
  FILE *pFile;
  result = (int)(pFile = fopen ("dbcal.bin","rb"));
  if (result == 0)
  {
    for (i=0;i<4096;i++)
     {
      y=-11114.+3.09*i;
      dbcal[i]=y;
     }
  }
  else
  {
    for (i=0;i<4096;i++) dbcal[i] = getw(pFile);
    fclose (pFile);
  }
  return(result);
}

float n(float f)
{
int intf;
float n1, n2, nerg;
intf=f/dfcal;
if (intf<0) intf=0;
if (intf>nfcal-2) intf=nfcal-2;
n1=fcal[intf];
n2=fcal[intf+1];
nerg=n1+(f/dfcal-intf)*(n2-n1);
return(nerg);
}

void f_cal( void)
{
  int i;
  float f,nu,no,ni;
  if (deltaf > dfcal)
    {
     nu=n(fu);
     no=n(fo);
       for (i=0; i<=GridWidth; i++)
	 {
	  f=fo+i*(fu-fo)/GridWidth;
	  ni=n(f);
	  raster[i]=4095.0*(ni-nu)/(no-nu);
	 }
    }
  else
    {
       for (i=0; i<=GridWidth; i++)
	  raster[i]=(GridWidth-i)*4095.0/GridWidth;
    }
}

int read_fcal( void)
{
  int i,result;
  float f,nu,no,ni;
  FILE *pFile;

  result = (int)(pFile = fopen ("fcal.bin","rb"));
  if (result == 0)
  {
    for (i=0;i<=560;i=i+10)
	fcal[i/10]=4095.5+i*(-7.8785+i*(0.12516e-1-i*.19805e-4));
    nfcal=57;
    dfcal=10.0;
  }
  else
  {
    fread(&nfcal,2,1,pFile);
    fread(&dfcal,4,1,pFile);
    fread(fcal,4,nfcal,pFile);
    fclose (pFile);
  }
  out_dac(0);
  delay(20);
  fu=frequenz()-ZF;
  out_dac(4095);
  delay(20);
  fo=frequenz()-ZF;
  deltaf=fu-fo;
  fc=0.5*(fu+fo);
  f_cal();
//  inttofile(raster,GridWidth+1,"tttt"); DebugInfo zum Frequenzraster
  return(result);
}

void graph_init( void)
{
  int virtscr=1280;
  int mode=0;
  BYTE color[48];

  clrscr();
  if (GetVESAInfo()!=0)
     { printf("\nKein VESA-BIOS installiert.\n\n");
       exit(0);}

  if (VESAInfo.VideoMemin64kb<8) //Karte mit 0,5 MByte?
     { printf("\nKarte hat weniger als 0.5 MByte Speicher!\n\n");
       exit(0);}


  ModeList=VESAInfo.VModeList;
      for( ; *ModeList!=0xffff ; ModeList++)
	if (GetVideoModeInfo(*ModeList)==0)
	  if ((ModeInfo.Width==width)  &&  //Auflsung
	      (ModeInfo.Height==height) && //suchen
	      (ModeInfo.MemModelType==3)) mode=*ModeList;
      if ( ! mode )
	{printf("\nKein passender VESA Videomodus gefunden!\n\n");
	 exit(0);}

SetVideoMode( mode , 0 );  //Modus setzen
textlines=16;              // 1 Textzeile am unteren Bildschirmrand
nlines=ModeInfo.Height-textlines;
InitMem();                 // Gesamten Bildspeicher lschen
SetLogScanLineLen(8*virtscr); //virtuelle Breite setzen
			   //*8 nicht VESA-konform!
vinit(0,Font8x8);          //Textfont laden
bpchar=8;                  //Bytes per Text-Character

//for (j=0;j<16;j++) out_AttrController(j,j); //Farbpalette
//Set_Palette(0,15,color);                    //ndern

}

void grid(int x1, int y1, int x2, int y2, int xgrids, int ygrids, int color)
{
int x,y,xstep,ystep;

set_color(color);
xstep=(x2-x1)/xgrids;
ystep=(y2-y1)/ygrids;

for (x=x1;x<=x2;x=x+xstep) line(x,y1,x,y2);
for (y=y1;y<=y2;y=y+ystep) line(x1,y,x2,y);
}

float f_max(void)
{
int x;
int max=-20000, s;
maxx=0;
s=1024*((segment+3)&3);
for (x=s+2;x<s+GridWidth-2;x++)
  {
   if (dbmess[x] > max)
     {
      max=dbmess[x];
      maxx=x;
     }
  }
maxx=maxx-s;
return(fo+maxx*(fu-fo)/GridWidth);
}

float bandw(void)
{
int x;
int max=-20000, s, bwref;
maxx=0;
s=1024*((segment+3)&3);
for (x=s+2;x<s+GridWidth-2;x++)
  {
   if (dbmess[x] > max)
     {
      max=dbmess[x];
      maxx=x;
     }
  }
bwref=max+lrdb;
for (x=maxx;x>s+2;x--)
  {
   if (dbmess[x]<bwref) break;
  }
lpos=mess[lx];
lx=x-s;
for (x=maxx;x<s+GridWidth-2;x++)
  {
   if (dbmess[x]<bwref) break;
  }
rpos=mess[rx];
rx=x-s;
maxx=maxx-s;
return(fo+maxx*(fu-fo)/GridWidth);
}

const dx=6, dy=12;
const color=1;
void move_marker(char number)
{
int x, y;
float freq, db, fl, fr;
//find coordinates
switch (marker[number].typ)
{
case 4:
       {
	freq=(fo+fu)*0.5;
	break;
       }
case 3:
       {
	bandw();
	fl=fo+lx*(fu-fo)/GridWidth;
	fr=fo+rx*(fu-fo)/GridWidth;
	freq=fl;
	marker[number].f=freq;
	break;
       }
case 5:
       {
	bandw();
	fr=fo+rx*(fu-fo)/GridWidth;
	fl=fo+lx*(fu-fo)/GridWidth;
        freq=fr;
	marker[number].f=freq;
	break;
       }
case 2:
       {
	freq=f_max();
	marker[number].f=freq;
	break;
       }
case 1:{
	freq=marker[number].f;
	break;
       }
case 0:
       {
	freq=marker[number].f;
	break;
       }
}
marker[number].xo=marker[number].x;
marker[number].yo=marker[number].y;
if ((freq>fo) && (freq<fu))
  {
   x=GridWidth*(freq-fo)/(fu-fo);
   marker[number].y=mess[x+1024*((segment+3)&3)];
   marker[number].db=dbmess[x+1024*((segment+3)&3)]/100.0;
   db=marker[number].db;
   marker[number].x=x+GridX;
  }
else return;

// set text
switch (marker[number].typ)
{
case 0: { sprintf(marker[number].text,
	    "  %1i: %8.2f MHz  %6.1f dB",number+1,freq,db);
	  break;
	}
case 1: { sprintf(marker[number].text,
	    "%1i-%1i: %8.2f MHz  %6.1f dB",marker[number].rm+1,number+1,
	    freq-marker[marker[number].rm].f,
	    db-marker[marker[number].rm].db);
	  break;
	}
case 2: { sprintf(marker[number].text,
	    "M-%1i: %8.2f MHz  %6.1f dB",number+1,freq,db);
	  break;
	}
case 3: { sprintf(marker[number].text,
	    "%1i fc @ %5.1f dB: %7.2f MHz",number+1,lrdb/100.,0.5*(fl+fr));
	  break;
	}
case 5: { sprintf(marker[number].text,
	    "%1i bw @ %5.1f dB: %7.2f MHz",number+1,lrdb/100.,fr-fl);
	  break;
	}
case 4: { sprintf(marker[number].text,
	    "  %1i: %8.2f MHz  %6.1f dB",number+1,freq,db);
	  break;
	}
}
PutString(width-224,16+number*16,marker[number].text,color);
// Reset old marker
x=marker[number].xo;
y=marker[number].yo;
put_char(x,y-dy-16,' ');
set_color(0);
line(x,y,x+dx,y-dy);
line(x,y,x-dx,y-dy);
line(x-dx,y-dy,x+dx,y-dy);
//set new marker
x=marker[number].x;
y=marker[number].y;
put_char(x,y-dy-16,number+0x31);
set_color(color);
line(x,y,x+dx,y-dy);
line(x,y,x-dx,y-dy);
line(x-dx,y-dy,x+dx,y-dy);
}

void markers(void)
{
char i;
out_Sequencer(0x2,color);	 //Bit-Plane color
for (i=0;i<nmark;i++)
  {
   move_marker(i);
  }
out_Sequencer(0x2,2);		 //Bit-Plane 2
}

void reset_marker(char number)
{
int x, y;
x=marker[number].x;
y=marker[number].y;
out_Sequencer(0x2,color);	 //Bit-Plane color
put_char(x,y-dy-16,' ');
PutString(width-224,16+number*16,"                            ",color);
set_color(0);
line(x,y,x+dx,y-dy);
line(x,y,x-dx,y-dy);
line(x-dx,y-dy,x+dx,y-dy);
out_Sequencer(0x2,2);		 //Bit-Plane 2
}



void draw_grid(int gwidth)
{
if (gwidth < 0)
     GridWidth=width;
else GridWidth=gwidth;
GridHeight=(height-32)/10;  //Hhe Grid festgelegt durch Auflsung
GridHeight=GridHeight*10;
GridWidth=(GridWidth)/10;
GridWidth=GridWidth*10+1;
if (GridWidth > width) GridWidth=GridWidth-10;
GridX=width-GridWidth;
GridY=16;
grid(GridX,16,width-1,GridHeight+16,10,10,4);
Ymin=16+GridHeight;
Ymax=16;
deltaY=-GridHeight;
}

void init_adc( void)
{
mask_interrupt(0xfc,0xff);
altvec=getvect(8);    //DOS-Uhrinterrupt = 0x8
setvect(8,adc);       //neue Interruptroutine ADC
im=0;
kaltstart=0;
}

void init_dac( void)
{
dac_inc=sweep_dac[sweep_i];
inttimer=sweep_t[sweep_i];
bottomline=height-16;
out_sweeptime();
outp(0x163,128);
}

void term_prog( void)
{
setvect(8,altvec);	    //Uhr-Interrupt restaurieren
set_timer(0);
mask_interrupt(0,0);
set_clock();		    //DOS Uhr nach RTC stellen
SetVideoMode(3,1);
}

void plot(unsigned int i, BYTE col)  //plottet Punkte von i...i+1 und
				     //lscht Punkte i-1024...i-1023
{
unsigned int j;
j=(i-1024) & 4095;
set_color(0);
putvline(GridX+(i & 1023),mess[j],mess[j+1]);
set_color(col);
putvline(GridX+(i & 1023),mess[i],mess[i+1]);
}

void out_dac(int erg)
{
if ( (erg ^ dac_old) & 255*256 )       //0 heisst MSBs gleich
  {
   outp(0x162,0xbf | band);	   //DAC weiterschalten
   outp(0x161,erg);
   outp(0x162,(erg / 256)  | 0x80 | band);
  }
else
  {
   outp(0x161,erg);
  }
}

void out_f(void)
{
char Line[128];
sprintf(Line,"Start:%7.2f MHz",fo+f_adder);
PutString(width-GridWidth,bottomline,Line,2);
sprintf(Line,"Stop:%7.2f MHz",fu+f_adder);
PutString(width-16*8,bottomline,Line,2);
sprintf(Line,"Center:%7.2f MHz",fc+f_adder);
PutString(width-GridWidth/2-9*8,bottomline,Line,2);
sprintf(Line,"Span:%7.2f MHz",deltaf);
PutString(width-GridWidth/4-11*8,bottomline,Line,2);
}

void out_sweeptime(void)
{
char Line[5];
stpcpy(Line,sweep_str[sweep_i]);
out_Sequencer(0x2,2);	 //Bit-Plane 2
PutString(0,bottomline-32,Line,2);
out_Sequencer(0x2,2);	 //Bit-Plane 2
}
